Index: wp-includes/pluggable-functions.php
===================================================================
--- wp-includes/pluggable-functions.php	(revision 2557)
+++ wp-includes/pluggable-functions.php	(working copy)
@@ -173,8 +173,12 @@
     
 	$comment = $wpdb->get_row("SELECT * FROM $wpdb->comments WHERE comment_ID='$comment_id' LIMIT 1");
 	$post = $wpdb->get_row("SELECT * FROM $wpdb->posts WHERE ID='$comment->comment_post_ID' LIMIT 1");
+	$currentuser = get_userdata($comment->user_id);
+
+	// Don't notify admin or post_author about their own comment
+	if ( $currentuser && ($post->post_author == $currentuser->ID || $currentuser->user_level >= 9) ) return false;
+
 	$user = $wpdb->get_row("SELECT * FROM $wpdb->users WHERE ID='$post->post_author' LIMIT 1");
-
 	if ('' == $user->user_email) return false; // If there's no email to send the comment to
 
 	$comment_author_domain = gethostbyaddr($comment->comment_author_IP);
@@ -266,4 +270,4 @@
 }
 endif;
 
-?>
\ No newline at end of file
+?>
